=== removed directory 'olive/backend'
=== removed file 'olive/backend/__init__.py'
=== removed file 'olive/backend/commit.py'
--- olive/backend/commit.py	2006-09-04 23:46:31 +0000
+++ olive/backend/commit.py	1970-01-01 00:00:00 +0000
@@ -1,109 +0,0 @@
-# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
-# Some parts of the code are:
-# Copyright (C) 2005, 2006 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-import bzrlib
-from bzrlib.errors import NoSuchFile
-
-from errors import ( LocalRequiresBoundBranch, NotBranchError, NonExistingParent,
-                    PathPrefixNotCreated, NoLocationKnown,
-                    DivergedBranchesError)
-
-def push(branch, location=None, remember=False, overwrite=False,
-         create_prefix=False):
-    """ Update a mirror of a branch.
-    
-    :param branch: the source branch
-    
-    :param location: the location of the branch that you'd like to update
-    
-    :param remember: if set, the location will be stored
-    
-    :param overwrite: overwrite target location if it diverged
-    
-    :param create_prefix: create the path leading up to the branch if it doesn't exist
-    
-    :return: number of revisions pushed
-    """
-    from bzrlib.branch import Branch
-    from bzrlib.transport import get_transport
-        
-    br_from = Branch.open_containing(branch)[0]
-    
-    stored_loc = br_from.get_push_location()
-    if location is None:
-        if stored_loc is None:
-            raise NoLocationKnown
-        else:
-            location = stored_loc
-
-    transport = get_transport(location)
-    location_url = transport.base
-
-    if br_from.get_push_location() is None or remember:
-        br_from.set_push_location(location_url)
-
-    old_rh = []
-
-    try:
-        dir_to = bzrlib.bzrdir.BzrDir.open(location_url)
-        br_to = dir_to.open_branch()
-    except NotBranchError:
-        # create a branch.
-        transport = transport.clone('..')
-        if not create_prefix:
-            try:
-                relurl = transport.relpath(location_url)
-                transport.mkdir(relurl)
-            except NoSuchFile:
-                raise NonExistingParent(location)
-        else:
-            current = transport.base
-            needed = [(transport, transport.relpath(location_url))]
-            while needed:
-                try:
-                    transport, relpath = needed[-1]
-                    transport.mkdir(relpath)
-                    needed.pop()
-                except NoSuchFile:
-                    new_transport = transport.clone('..')
-                    needed.append((new_transport,
-                                   new_transport.relpath(transport.base)))
-                    if new_transport.base == transport.base:
-                        raise PathPrefixNotCreated
-        dir_to = br_from.bzrdir.clone(location_url,
-            revision_id=br_from.last_revision())
-        br_to = dir_to.open_branch()
-        count = len(br_to.revision_history())
-    else:
-        old_rh = br_to.revision_history()
-        try:
-            try:
-                tree_to = dir_to.open_workingtree()
-            except NotLocalUrl:
-                # FIXME - what to do here? how should we warn the user?
-                #warning('This transport does not update the working '
-                #        'tree of: %s' % (br_to.base,))
-                count = br_to.pull(br_from, overwrite)
-            except NoWorkingTree:
-                count = br_to.pull(br_from, overwrite)
-            else:
-                count = tree_to.pull(br_from, overwrite)
-        except DivergedBranches:
-            raise DivergedBranchesError
-    
-    return count

=== removed file 'olive/backend/info.py'
--- olive/backend/info.py	2006-09-04 23:46:31 +0000
+++ olive/backend/info.py	1970-01-01 00:00:00 +0000
@@ -1,480 +0,0 @@
-# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
-# Some parts of the code are:
-# Copyright (C) 2005, 2006 by Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-import bzrlib
-import bzrlib.errors as errors
-
-from bzrlib.branch import Branch
-from bzrlib.workingtree import WorkingTree
-
-from bzrlib.errors import (NotBranchError, PermissionDenied, BzrError)
-
-class DifferentBranchesError(BzrError):
-    """ Occurs if the specified files are in different branches
-    
-    May occur in:
-        info.diff()
-    """
-
-
-class PrefixFormatError(BzrError):
-    """ Occurs if the prefix is badly formatted
-    
-    May occur in:
-        info.diff()
-    """
-
-
-class RevisionValueError(BzrError):
-    """ Invalid revision value provided
-    
-    May occur in:
-        info.log()
-    """
-
-
-def diff(revision=None, file_list=None, diff_options=None, prefix=None):
-    """ Save the diff into a temporary file.
-    
-    :param revision: a list of revision numbers (one or two elements)
-    
-    :param file_list: list of files you want to diff
-    
-    :param diff_options: external diff options
-    
-    :param prefix: 0 - p0, 1 - p1, or specify prefixes in the form of old/:new/
-    
-    :return: path to the temporary file which contains the diff output (the frontend has to remove it!)
-    """
-    from tempfile import mkstemp
-    
-    from bzrlib.builtins import internal_tree_files
-    from bzrlib.diff import show_diff_trees
-    from bzrlib.revisionspec import RevisionSpec_int
-    from bzrlib.workingtree import WorkingTree
-    
-    from info_helper import diff_helper
-
-    if (prefix is None) or (prefix == '0'):
-        # diff -p0 format
-        old_label = ''
-        new_label = ''
-    elif prefix == '1':
-        old_label = 'old/'
-        new_label = 'new/'
-    else:
-        if not ':' in prefix:
-            raise PrefixFormatError
-        old_label, new_label = prefix.split(":")
-    
-    try:
-        tree1, file_list = internal_tree_files(file_list)
-        tree2 = None
-        b = None
-        b2 = None
-    except errors.FileInWrongBranch:
-        if len(file_list) != 2:
-            raise DifferentBranchesError
-
-        tree1, file1 = WorkingTree.open_containing(file_list[0])
-        tree2, file2 = WorkingTree.open_containing(file_list[1])
-    
-        if file1 != "" or file2 != "":
-            raise DifferentBranchesError
-    
-        file_list = None
-    
-    tmpfile = mkstemp(prefix='olive_')
-    tmpfp = open(tmpfile[1], 'w')
-    
-    if revision is not None:
-        if tree2 is not None:
-            raise RevisionValueError
-    
-        if len(revision) >= 1:
-            revision[0] = RevisionSpec_int(revision[0])
-        if len(revision) == 2:
-            revision[1] = RevisionSpec_int(revision[1])
-        
-        if (len(revision) == 1) or (revision[1].spec is None):
-            ret = diff_helper(tree1, file_list, diff_options,
-                              revision[0], 
-                              old_label=old_label, new_label=new_label,
-                              output=tmpfp)
-        elif len(revision) == 2:
-            ret = diff_helper(tree1, file_list, diff_options,
-                              revision[0], revision[1],
-                              old_label=old_label, new_label=new_label,
-                              output=tmpfp)
-        else:
-            raise RevisionValueError
-    else:
-        if tree2 is not None:
-            ret = show_diff_trees(tree1, tree2, tmpfp, 
-                                  specific_files=file_list,
-                                  external_diff_options=diff_options,
-                                  old_label=old_label, new_label=new_label)
-        else:
-            ret = diff_helper(tree1, file_list, diff_options,
-                              old_label=old_label, new_label=new_label,
-                              output=tmpfp)
-    
-    tmpfp.close()
-    
-    if ret == 0:
-        return False
-    else:
-        return tmpfile[1]
-
-def get_push_location(location):
-    """ Get the stored push location of a branch.
-    
-    :param location: the path to the branch
-    
-    :return: the stored location
-    """
-    from bzrlib.branch import Branch
-    
-    branch = Branch.open_containing(location)[0]
-    
-    return branch.get_push_location()
-
-def info(location):
-    """ Get info about branch, working tree, and repository
-    
-    :param location: the location of the branch/working tree/repository
-    
-    :return: the information in dictionary format
-    
-    The following informations are delivered (if available):
-    ret['location']['lightcoroot']: Light checkout root
-    ret['location']['sharedrepo']: Shared repository
-    ret['location']['repobranch']: Repository branch
-    ret['location']['cobranch']: Checkout of branch
-    ret['location']['repoco']: Repository checkout
-    ret['location']['coroot']: Checkout root
-    ret['location']['branchroot']: Branch root
-    ret['related']['parentbranch']: Parent branch
-    ret['related']['publishbranch']: Publish to branch
-    ret['format']['control']: Control format
-    ret['format']['workingtree']: Working tree format
-    ret['format']['branch']: Branch format
-    ret['format']['repository']: Repository format
-    ret['locking']['workingtree']: Working tree lock status
-    ret['locking']['branch']: Branch lock status
-    ret['locking']['repository']: Repository lock status
-    ret['missing']['branch']: Missing revisions in branch
-    ret['missing']['workingtree']: Missing revisions in working tree
-    ret['wtstats']['unchanged']: Unchanged files
-    ret['wtstats']['modified']: Modified files
-    ret['wtstats']['added']: Added files
-    ret['wtstats']['removed']: Removed files
-    ret['wtstats']['renamed']: Renamed files
-    ret['wtstats']['unknown']: Unknown files
-    ret['wtstats']['ignored']: Ingnored files
-    ret['wtstats']['subdirs']: Versioned subdirectories
-    ret['brstats']['revno']: Revisions in branch
-    ret['brstats']['commiters']: Number of commiters
-    ret['brstats']['age']: Age of branch in days
-    ret['brstats']['firstrev']: Time of first revision
-    ret['brstats']['lastrev']: Time of last revision
-    ret['repstats']['revisions']: Revisions in repository
-    ret['repstats']['size']: Size of repository in bytes
-    """
-    import bzrlib.bzrdir as bzrdir
-    
-    import info_helper
-    
-    ret = {}
-    a_bzrdir = bzrdir.BzrDir.open_containing(location)[0]
-
-    try:
-        working = a_bzrdir.open_workingtree()
-        working.lock_read()
-        try:
-            branch = working.branch
-            repository = branch.repository
-            control = working.bzrdir
-            
-            ret['location'] = info_helper.get_location_info(repository, branch, working)
-            ret['related'] = info_helper.get_related_info(branch)
-            ret['format'] = info_helper.get_format_info(control, repository, branch, working)
-            ret['locking'] = info_helper.get_locking_info(repository, branch, working)
-            ret['missing'] = {}
-            ret['missing']['branch'] = info_helper.get_missing_revisions_branch(branch)
-            ret['missing']['workingtree'] = info_helper.get_missing_revisions_working(working)
-            ret['wtstats'] = info_helper.get_working_stats(working)
-            ret['brstats'] = info_helper.get_branch_stats(branch)
-            ret['repstats'] = info_helper.get_repository_stats(repository)
-        finally:
-            working.unlock()
-            return ret
-        return
-    except (errors.NoWorkingTree, errors.NotLocalUrl):
-        pass
-
-    try:
-        branch = a_bzrdir.open_branch()
-        branch.lock_read()
-        try:
-            ret['location'] = info_helper.get_location_info(repository, branch)
-            ret['related'] = info_helper.get_related_info(branch)
-            ret['format'] = info_helper.get_format_info(control, repository, branch)
-            ret['locking'] = info_helper.get_locking_info(repository, branch)
-            ret['missing']['branch'] = info_helper.get_missing_revisions_branch(branch)
-            ret['brstats'] = info_helper.get_branch_stats(branch)
-            ret['repstats'] = info_helper.get_repository_stats(repository)
-        finally:
-            branch.unlock()
-            return ret
-        return
-    except errors.NotBranchError:
-        pass
-
-    try:
-        repository = a_bzrdir.open_repository()
-        repository.lock_read()
-        try:
-            ret['location'] = info_helper.get_location_info(repository)
-            ret['format'] = info_helper.get_format_info(control, repository)
-            ret['locking'] = info_helper.get_locking_info(repository)
-            ret['repstats'] = info_helper.get_repository_stats(repository)
-        finally:
-            repository.unlock()
-            return ret
-        return
-    except errors.NoRepositoryPresent:
-        pass
-
-def is_branch(location):
-    """ Check if the location is a branch.
-    
-    :param location: the location you want to check
-    
-    :return: True or False respectively
-    """
-    try:
-        branch = Branch.open_containing(location)[0]
-    except errors.NotBranchError:
-        return False
-    else:
-        return True
-        
-
-def is_checkout(location):
-    """ Check if the location is a checkout.
-    
-    :param location: the location you want to check
-    
-    :return: True or False respectively
-    """
-    branch = Branch.open_containing(location)[0]
-    
-    try:
-        working = WorkingTree.open_containing(location)[0]
-    except:
-        raise
-    
-    working_path = working.bzrdir.root_transport.base
-    branch_path = branch.bzrdir.root_transport.base
-    
-    if working_path != branch_path:
-        # lightweight checkout
-        return True
-    elif branch.get_bound_location():
-        # checkout
-        return True
-    else:
-        return False
-
-def log(location, timezone='original', verbose=False, show_ids=False,
-        forward=False, revision=None, log_format=None, message=None,
-        long=False, short=False, line=False):
-    """ Print log into a temporary file.
-    
-    :param location: location of local/remote branch or file
-    
-    :param timzone: requested timezone
-    
-    :param verbose: verbose output
-    
-    :param show_ids:
-    
-    :param forward: if True, start from the earliest entry
-    
-    :param revision: revision range as a list ([from, to])
-    
-    :param log_format: line, short, long
-    
-    :param message: show revisions whose message matches this regexp
-    
-    :param long: long log format
-    
-    :param short: short log format
-    
-    :param line: line log format
-    
-    :return: full path to the temporary file containing the log (the frontend has to remove it!)
-    """
-    from tempfile import mkstemp
-    
-    from bzrlib import bzrdir    
-    from bzrlib.builtins import get_log_format
-    from bzrlib.log import log_formatter, show_log
-    from bzrlib.revisionspec import RevisionSpec_int
-    
-    assert message is None or isinstance(message, basestring), \
-        "invalid message argument %r" % message
-    direction = (forward and 'forward') or 'reverse'
-        
-    # log everything
-    file_id = None
-    
-    # find the file id to log:
-    dir, fp = bzrdir.BzrDir.open_containing(location)
-    b = dir.open_branch()
-    if fp != '':
-        try:
-            # might be a tree:
-            inv = dir.open_workingtree().inventory
-        except (errors.NotBranchError, errors.NotLocalUrl):
-            # either no tree, or is remote.
-            inv = b.basis_tree().inventory
-        file_id = inv.path2id(fp)
-
-    if revision is not None:
-        if len(revision) >= 1:
-            revision[0] = RevisionSpec_int(revision[0])
-        if len(revision) == 2:
-            revision[1] = RevisionSpec_int(revision[1])
-    
-    if revision is None:
-        rev1 = None
-        rev2 = None
-    elif len(revision) == 1:
-        rev1 = rev2 = revision[0].in_history(b).revno
-    elif len(revision) == 2:
-        if revision[0].spec is None:
-            # missing begin-range means first revision
-            rev1 = 1
-        else:
-            rev1 = revision[0].in_history(b).revno
-
-        if revision[1].spec is None:
-            # missing end-range means last known revision
-            rev2 = b.revno()
-        else:
-            rev2 = revision[1].in_history(b).revno
-    else:
-        raise RevisionValueError
-
-    # By this point, the revision numbers are converted to the +ve
-    # form if they were supplied in the -ve form, so we can do
-    # this comparison in relative safety
-    if rev1 > rev2:
-        (rev2, rev1) = (rev1, rev2)
-
-    if (log_format == None):
-        default = b.get_config().log_format()
-        log_format = get_log_format(long=long, short=short, line=line, 
-                                    default=default)
-    
-    tmpfile = mkstemp(prefix='olive_')
-    tmpfp = open(tmpfile[1], 'w')
-    
-    lf = log_formatter(log_format,
-                       show_ids=show_ids,
-                       to_file=tmpfp,
-                       show_timezone=timezone)
-
-    show_log(b,
-             lf,
-             file_id,
-             verbose=verbose,
-             direction=direction,
-             start_revision=rev1,
-             end_revision=rev2,
-             search=message)
-    
-    tmpfp.close()
-    return tmpfile[1]
-
-def nick(branch, nickname=None):
-    """ Get or set nickname.
-    
-    :param branch: path to the branch
-    
-    :param nickname: if specified, the nickname will be set
-    
-    :return: nickname
-    """
-    try:
-        branch = Branch.open_containing(branch)[0]
-    except errors.NotBranchError:
-        raise NotBranchError
-    
-    if nickname is not None:
-        branch.nick = nickname
-
-    return branch.nick    
-
-def revno(branch):
-    """ Get current revision number for specified branch
-    
-    :param branch: path to the branch
-    
-    :return: revision number
-    """
-    try:
-        revno = Branch.open_containing(branch)[0].revno()
-    except errors.NotBranchError:
-        raise NotBranchError
-    else:
-        return revno
-
-def version():
-    """ Get version information from bzr
-    
-    :return: bzrlib version
-    """
-    return bzrlib.__version__
-
-def whoami(branch=None, email=False):
-    """ Get user's data (name and email address)
-    
-    :param branch: if specified, the user's data will be looked up in the branch's config
-    
-    :param email: if True, only the email address will be returned
-    
-    :return: user info (only email address if email is True)
-    """
-    from bzrlib.workingtree import WorkingTree
-    
-    if branch is not None:
-        try:
-            b = WorkingTree.open_containing(u'.')[0].branch
-            config = bzrlib.config.BranchConfig(b)
-        except NotBranchError:
-            config = bzrlib.config.GlobalConfig()
-    else:
-        config = bzrlib.config.GlobalConfig()
-        
-    if email:
-        return config.user_email()
-    else:
-        return config.username()

=== removed file 'olive/backend/info_helper.py'
--- olive/backend/info_helper.py	2006-08-10 11:49:24 +0000
+++ olive/backend/info_helper.py	1970-01-01 00:00:00 +0000
@@ -1,304 +0,0 @@
-# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
-# Some parts of the code are:
-# Copyright (C) 2005, 2006 by Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-import time
-
-import bzrlib
-
-import bzrlib.osutils as osutils
-
-from bzrlib.info import _repo_relpath
-from bzrlib.missing import find_unmerged
-
-def get_location_info(repository, branch=None, working=None):
-    """ Get known locations for working, branch and repository.
-    
-    :return: a dictionary containing the needed infos
-    """
-    ret = {}
-    repository_path = repository.bzrdir.root_transport.base
-    if working and branch:
-        working_path = working.bzrdir.root_transport.base
-        branch_path = branch.bzrdir.root_transport.base
-        if working_path != branch_path:
-            # lightweight checkout
-            ret['lightcoroot'] = working_path
-            if repository.is_shared():
-                # lightweight checkout of branch in shared repository
-                ret['sharedrepo'] = repository_path
-                ret['repobranch'] = _repo_relpath(repository_path, branch_path)
-            else:
-                # lightweight checkout of standalone branch
-                ret['cobranch'] = branch_path
-        elif repository.is_shared():
-            # branch with tree inside shared repository
-            ret['sharedrepo'] = repository_path
-            ret['repoco'] = _repo_relpath(repository_path, branch_path)
-        elif branch.get_bound_location():
-            # normal checkout
-            ret['coroot'] = working_path
-            ret['cobranch'] = branch.get_bound_location()
-        else:
-            # standalone
-            ret['branchroot'] = working_path
-    elif branch:
-        branch_path = branch.bzrdir.root_transport.base
-        if repository.is_shared():
-            # branch is part of shared repository
-            ret['sharedrepo'] = repository_path
-            ret['repobranch'] = _repo_relpath(repository_path, branch_path)
-        else:
-            # standalone branch
-            ret['branchroot'] = branch_path
-    else:
-        # shared repository
-        assert repository.is_shared()
-        ret['sharedrepo'] = repository_path
-    
-    return ret
-
-def get_related_info(branch):
-    """ Get parent and push location of branch.
-    
-    :return: a dictionary containing the needed infos
-    """
-    ret = {}
-    if branch.get_parent() or branch.get_push_location():
-        if branch.get_parent():
-            ret['parentbranch'] = branch.get_parent()
-        if branch.get_push_location():
-            ret['publishbranch'] = branch.get_push_location()
-    
-    return ret
-
-
-def get_format_info(control=None, repository=None, branch=None, working=None):
-    """ Get known formats for control, working, branch and repository.
-    
-    :return: a dictionary containing the needed infos
-    """
-    ret = {}
-    if control:
-        ret['control'] = control._format.get_format_description()
-    if working:
-        ret['workingtree'] = working._format.get_format_description()
-    if branch:
-        ret['branch'] = branch._format.get_format_description()
-    if repository:
-        ret['repository'] = repository._format.get_format_description()
-    
-    return ret
-
-
-def get_locking_info(repository, branch=None, working=None):
-    """ Get locking status of working, branch and repository.
-    
-    :return: a dictionary containing the needed infos
-    """
-    ret = {}
-    if (repository.get_physical_lock_status() or
-        (branch and branch.get_physical_lock_status()) or
-        (working and working.get_physical_lock_status())):
-        if working:
-            if working.get_physical_lock_status():
-                status = 'locked'
-            else:
-                status = 'unlocked'
-            ret['workingtree'] = status
-        if branch:
-            if branch.get_physical_lock_status():
-                status = 'locked'
-            else:
-                status = 'unlocked'
-            ret['branch'] = status
-        if repository:
-            if repository.get_physical_lock_status():
-                status = 'locked'
-            else:
-                status = 'unlocked'
-            ret['repository'] = status
-    
-    return ret
-
-def get_missing_revisions_branch(branch):
-    """ Get missing master revisions in branch.
-    
-    :return: a dictionary containing the needed infos
-    """
-    ret = {}
-    # Try with inaccessible branch ?
-    master = branch.get_master_branch()
-    if master:
-        local_extra, remote_extra = find_unmerged(branch, master)
-        if remote_extra:
-            ret = len(remote_extra)
-    
-    return ret
-
-
-def get_missing_revisions_working(working):
-    """ Get missing revisions in working tree.
-    
-    :return: a dictionary containing the needed infos
-    """
-    if (bzrlib.version_info[0] == 0) and (bzrlib.version_info[1] < 9):
-        # function deprecated after 0.9
-        from bzrlib.delta import compare_trees
-
-    ret = {}
-    branch = working.branch
-    basis = working.basis_tree()
-    work_inv = working.inventory
-    
-    if (bzrlib.version_info[0] == 0) and (bzrlib.version_info[1] < 9):
-        delta = compare_trees(basis, working, want_unchanged=True)
-    else:
-        delta = working.changes_from(basis, want_unchanged=True)
-
-    history = branch.revision_history()
-    tree_last_id = working.last_revision()
-
-    if len(history) and tree_last_id != history[-1]:
-        tree_last_revno = branch.revision_id_to_revno(tree_last_id)
-        missing_count = len(history) - tree_last_revno
-        ret = missing_count
-    
-    return ret
-
-
-def get_working_stats(working):
-    """ Get statistics about a working tree.
-    
-    :return: a dictionary containing the needed infos
-    """
-    if (bzrlib.version_info[0] == 0) and (bzrlib.version_info[1] < 9):
-        # function deprecated after 0.9
-        from bzrlib.delta import compare_trees
-    
-    ret = {}
-    basis = working.basis_tree()
-    work_inv = working.inventory
-    
-    if (bzrlib.version_info[0] == 0) and (bzrlib.version_info[1] < 9):
-        delta = compare_trees(basis, working, want_unchanged=True)
-    else:
-        delta = working.changes_from(basis, want_unchanged=True)
-
-    ret['unchanged'] = len(delta.unchanged)
-    ret['modified'] = len(delta.modified)
-    ret['added'] = len(delta.added)
-    ret['removed'] = len(delta.removed)
-    ret['renamed'] = len(delta.renamed)
-
-    ignore_cnt = unknown_cnt = 0
-    for path in working.extras():
-        if working.is_ignored(path):
-            ignore_cnt += 1
-        else:
-            unknown_cnt += 1
-    ret['unknown'] = unknown_cnt
-    ret['ignored'] = ignore_cnt
-
-    dir_cnt = 0
-    for file_id in work_inv:
-        if work_inv.get_file_kind(file_id) == 'directory':
-            dir_cnt += 1
-    ret['subdirs'] = dir_cnt
-
-    return ret
-
-def get_branch_stats(branch):
-    """ Get statistics about a branch.
-    
-    :return: a dictionary containing the needed infos
-    """
-    ret = {}
-    repository = branch.repository
-    history = branch.revision_history()
-
-    revno = len(history)
-    ret['revno'] = revno 
-    committers = {}
-    for rev in history:
-        committers[repository.get_revision(rev).committer] = True
-    ret['commiters'] = len(committers)
-    if revno > 0:
-        firstrev = repository.get_revision(history[0])
-        age = int((time.time() - firstrev.timestamp) / 3600 / 24)
-        ret['age'] = age
-        ret['firstrev'] = osutils.format_date(firstrev.timestamp,
-                                              firstrev.timezone)
-
-        lastrev = repository.get_revision(history[-1])
-        ret['lastrev'] = osutils.format_date(lastrev.timestamp,
-                                             lastrev.timezone)
-
-    return ret
-
-def get_repository_stats(repository):
-    """ Get statistics about a repository.
-    
-    :return: a dictionary containing the needed infos
-    """
-    ret = {}
-    if repository.bzrdir.root_transport.listable():
-        c, t = repository._revision_store.total_size(repository.get_transaction())
-        ret['revisions'] = c
-        ret['size'] = t
-
-    return ret
-
-def diff_helper(tree, specific_files, external_diff_options, 
-                    old_revision_spec=None, new_revision_spec=None,
-                    old_label='a/', new_label='b/', output=None):
-    """ Helper for diff.
-
-    :param tree: a WorkingTree
-
-    :param specific_files: the specific files to compare, or None
-
-    :param external_diff_options: if non-None, run an external diff, and pass it these options
-
-    :param old_revision_spec: if None, use basis tree as old revision, otherwise use the tree for the specified revision. 
-
-    :param new_revision_spec:  if None, use working tree as new revision, otherwise use the tree for the specified revision.
-    """
-    import sys
-    
-    from bzrlib.diff import show_diff_trees
-    
-    if output == None:
-        output = sys.stdout
-    
-    def spec_tree(spec):
-        revision_id = spec.in_store(tree.branch).rev_id
-        return tree.branch.repository.revision_tree(revision_id)
-    
-    if old_revision_spec is None:
-        old_tree = tree.basis_tree()
-    else:
-        old_tree = spec_tree(old_revision_spec)
-
-    if new_revision_spec is None:
-        new_tree = tree
-    else:
-        new_tree = spec_tree(new_revision_spec)
-
-    return show_diff_trees(old_tree, new_tree, output, specific_files,
-                           external_diff_options,
-                           old_label=old_label, new_label=new_label)

=== modified file 'olive/frontend/gtk/__init__.py'
--- olive/frontend/gtk/__init__.py	2006-09-05 01:37:16 +0000
+++ olive/frontend/gtk/__init__.py	2006-09-05 01:51:53 +0000
@@ -32,7 +32,6 @@
     sys.exit(1)
 
 from handler import OliveHandler
-from olive.backend.info import is_branch
 import bzrlib.errors as errors
 
 # Olive GTK UI version
@@ -229,57 +228,53 @@
         tvcolumn_status.pack_start(cell, True)
         tvcolumn_status.add_attribute(cell, 'text', 2)
         
-        # Check if current directory is a branch
+        # Check if current directory is versioned
         try:
-            br = is_branch(self.comm.get_path())
-        except errors.PermissionDenied:
-            pass
-        else:
-            if br:
-                # Activate some items
-                self.comm.menuitem_branch_init.set_sensitive(False)
-                self.comm.menuitem_branch_get.set_sensitive(True)
-                self.comm.menuitem_branch_checkout.set_sensitive(True)
-                self.comm.menuitem_branch_pull.set_sensitive(True)
-                self.comm.menuitem_branch_push.set_sensitive(True)
-                self.comm.menuitem_branch_commit.set_sensitive(True)
-                self.comm.menuitem_branch_status.set_sensitive(True)
-                self.comm.menuitem_branch_missing.set_sensitive(True)
-                self.comm.menuitem_stats.set_sensitive(True)
-                self.comm.menuitem_add_files.set_sensitive(True)
-                self.comm.menuitem_remove_files.set_sensitive(True)
-                self.comm.menuitem_file_make_directory.set_sensitive(True)
-                self.comm.menuitem_file_rename.set_sensitive(True)
-                self.comm.menuitem_file_move.set_sensitive(True)
-                #self.comm.menutoolbutton_diff.set_sensitive(True)
-                self.comm.toolbutton_diff.set_sensitive(True)
-                self.comm.toolbutton_log.set_sensitive(True)
-                self.comm.toolbutton_commit.set_sensitive(True)
-                self.comm.toolbutton_pull.set_sensitive(True)
-                self.comm.toolbutton_push.set_sensitive(True)
-            else:
-                # Deactivate some items
-                self.comm.menuitem_branch_init.set_sensitive(True)
-                self.comm.menuitem_branch_get.set_sensitive(False)
-                self.comm.menuitem_branch_checkout.set_sensitive(False)
-                self.comm.menuitem_branch_pull.set_sensitive(False)
-                self.comm.menuitem_branch_push.set_sensitive(False)
-                self.comm.menuitem_branch_commit.set_sensitive(False)
-                self.comm.menuitem_branch_status.set_sensitive(False)
-                self.comm.menuitem_branch_missing.set_sensitive(False)
-                self.comm.menuitem_stats.set_sensitive(False)
-                self.comm.menuitem_add_files.set_sensitive(False)
-                self.comm.menuitem_remove_files.set_sensitive(False)
-                self.comm.menuitem_file_make_directory.set_sensitive(False)
-                self.comm.menuitem_file_rename.set_sensitive(False)
-                self.comm.menuitem_file_move.set_sensitive(False)
-                #self.comm.menutoolbutton_diff.set_sensitive(False)
-                self.comm.toolbutton_diff.set_sensitive(False)
-                self.comm.toolbutton_log.set_sensitive(False)
-                self.comm.toolbutton_commit.set_sensitive(False)
-                self.comm.toolbutton_pull.set_sensitive(False)
-                self.comm.toolbutton_push.set_sensitive(False)
-        
+            Branch.open_containing(self.comm.get_path())
+            # Activate some items
+            self.comm.menuitem_branch_init.set_sensitive(False)
+            self.comm.menuitem_branch_get.set_sensitive(True)
+            self.comm.menuitem_branch_checkout.set_sensitive(True)
+            self.comm.menuitem_branch_pull.set_sensitive(True)
+            self.comm.menuitem_branch_push.set_sensitive(True)
+            self.comm.menuitem_branch_commit.set_sensitive(True)
+            self.comm.menuitem_branch_status.set_sensitive(True)
+            self.comm.menuitem_branch_missing.set_sensitive(True)
+            self.comm.menuitem_stats.set_sensitive(True)
+            self.comm.menuitem_add_files.set_sensitive(True)
+            self.comm.menuitem_remove_files.set_sensitive(True)
+            self.comm.menuitem_file_make_directory.set_sensitive(True)
+            self.comm.menuitem_file_rename.set_sensitive(True)
+            self.comm.menuitem_file_move.set_sensitive(True)
+            #self.comm.menutoolbutton_diff.set_sensitive(True)
+            self.comm.toolbutton_diff.set_sensitive(True)
+            self.comm.toolbutton_log.set_sensitive(True)
+            self.comm.toolbutton_commit.set_sensitive(True)
+            self.comm.toolbutton_pull.set_sensitive(True)
+            self.comm.toolbutton_push.set_sensitive(True)
+        except NotBranchError:
+            # Deactivate some items
+            self.comm.menuitem_branch_init.set_sensitive(True)
+            self.comm.menuitem_branch_get.set_sensitive(False)
+            self.comm.menuitem_branch_checkout.set_sensitive(False)
+            self.comm.menuitem_branch_pull.set_sensitive(False)
+            self.comm.menuitem_branch_push.set_sensitive(False)
+            self.comm.menuitem_branch_commit.set_sensitive(False)
+            self.comm.menuitem_branch_status.set_sensitive(False)
+            self.comm.menuitem_branch_missing.set_sensitive(False)
+            self.comm.menuitem_stats.set_sensitive(False)
+            self.comm.menuitem_add_files.set_sensitive(False)
+            self.comm.menuitem_remove_files.set_sensitive(False)
+            self.comm.menuitem_file_make_directory.set_sensitive(False)
+            self.comm.menuitem_file_rename.set_sensitive(False)
+            self.comm.menuitem_file_move.set_sensitive(False)
+            #self.comm.menutoolbutton_diff.set_sensitive(False)
+            self.comm.toolbutton_diff.set_sensitive(False)
+            self.comm.toolbutton_log.set_sensitive(False)
+            self.comm.toolbutton_commit.set_sensitive(False)
+            self.comm.toolbutton_pull.set_sensitive(False)
+            self.comm.toolbutton_push.set_sensitive(False)
+    
         # set cursor to default
         self.comm.set_busy(self.treeview_right, False)
 

=== modified file 'olive/frontend/gtk/commit.py'
--- olive/frontend/gtk/commit.py	2006-09-04 23:46:31 +0000
+++ olive/frontend/gtk/commit.py	2006-09-05 01:51:53 +0000
@@ -93,8 +93,9 @@
                                      _('You can perform this action only in a branch.'))
             self.close()
         else:
-            from olive.backend.info import is_checkout
-            if is_checkout(self.comm.get_path()):
+            branch = Branch.open_containing(self.comm.get_path())[0]
+
+            if branch.get_bound_location() is not None:
                 # we have a checkout, so the local commit checkbox must appear
                 self.checkbutton_local.show()
             

=== modified file 'olive/frontend/gtk/handler.py'
--- olive/frontend/gtk/handler.py	2006-09-05 01:20:15 +0000
+++ olive/frontend/gtk/handler.py	2006-09-05 01:51:53 +0000
@@ -27,7 +27,6 @@
 except:
     sys.exit(1)
 
-from olive.backend.info import is_branch
 import bzrlib.errors as errors
 from bzrlib.branch import Branch
 

=== modified file 'olive/frontend/gtk/info.py'
--- olive/frontend/gtk/info.py	2006-09-04 23:33:13 +0000
+++ olive/frontend/gtk/info.py	2006-09-05 01:51:53 +0000
@@ -30,7 +30,117 @@
     sys.exit(1)
 
 import bzrlib.errors as errors
-import olive.backend.info as info
+
+def info(location):
+    """ Get info about branch, working tree, and repository
+    
+    :param location: the location of the branch/working tree/repository
+    
+    :return: the information in dictionary format
+    
+    The following informations are delivered (if available):
+    ret['location']['lightcoroot']: Light checkout root
+    ret['location']['sharedrepo']: Shared repository
+    ret['location']['repobranch']: Repository branch
+    ret['location']['cobranch']: Checkout of branch
+    ret['location']['repoco']: Repository checkout
+    ret['location']['coroot']: Checkout root
+    ret['location']['branchroot']: Branch root
+    ret['related']['parentbranch']: Parent branch
+    ret['related']['publishbranch']: Publish to branch
+    ret['format']['control']: Control format
+    ret['format']['workingtree']: Working tree format
+    ret['format']['branch']: Branch format
+    ret['format']['repository']: Repository format
+    ret['locking']['workingtree']: Working tree lock status
+    ret['locking']['branch']: Branch lock status
+    ret['locking']['repository']: Repository lock status
+    ret['missing']['branch']: Missing revisions in branch
+    ret['missing']['workingtree']: Missing revisions in working tree
+    ret['wtstats']['unchanged']: Unchanged files
+    ret['wtstats']['modified']: Modified files
+    ret['wtstats']['added']: Added files
+    ret['wtstats']['removed']: Removed files
+    ret['wtstats']['renamed']: Renamed files
+    ret['wtstats']['unknown']: Unknown files
+    ret['wtstats']['ignored']: Ingnored files
+    ret['wtstats']['subdirs']: Versioned subdirectories
+    ret['brstats']['revno']: Revisions in branch
+    ret['brstats']['commiters']: Number of commiters
+    ret['brstats']['age']: Age of branch in days
+    ret['brstats']['firstrev']: Time of first revision
+    ret['brstats']['lastrev']: Time of last revision
+    ret['repstats']['revisions']: Revisions in repository
+    ret['repstats']['size']: Size of repository in bytes
+    """
+    import bzrlib.bzrdir as bzrdir
+    
+    import info_helper
+    
+    ret = {}
+    try:
+        a_bzrdir = bzrdir.BzrDir.open_containing(location)[0]
+    except errors.NotBranchError:
+        raise NotBranchError(location)
+
+    try:
+        working = a_bzrdir.open_workingtree()
+        working.lock_read()
+        try:
+            branch = working.branch
+            repository = branch.repository
+            control = working.bzrdir
+            
+            ret['location'] = info_helper.get_location_info(repository, branch, working)
+            ret['related'] = info_helper.get_related_info(branch)
+            ret['format'] = info_helper.get_format_info(control, repository, branch, working)
+            ret['locking'] = info_helper.get_locking_info(repository, branch, working)
+            ret['missing'] = {}
+            ret['missing']['branch'] = info_helper.get_missing_revisions_branch(branch)
+            ret['missing']['workingtree'] = info_helper.get_missing_revisions_working(working)
+            ret['wtstats'] = info_helper.get_working_stats(working)
+            ret['brstats'] = info_helper.get_branch_stats(branch)
+            ret['repstats'] = info_helper.get_repository_stats(repository)
+        finally:
+            working.unlock()
+            return ret
+        return
+    except (errors.NoWorkingTree, errors.NotLocalUrl):
+        pass
+
+    try:
+        branch = a_bzrdir.open_branch()
+        branch.lock_read()
+        try:
+            ret['location'] = info_helper.get_location_info(repository, branch)
+            ret['related'] = info_helper.get_related_info(branch)
+            ret['format'] = info_helper.get_format_info(control, repository, branch)
+            ret['locking'] = info_helper.get_locking_info(repository, branch)
+            ret['missing']['branch'] = info_helper.get_missing_revisions_branch(branch)
+            ret['brstats'] = info_helper.get_branch_stats(branch)
+            ret['repstats'] = info_helper.get_repository_stats(repository)
+        finally:
+            branch.unlock()
+            return ret
+        return
+    except errors.NotBranchError:
+        pass
+
+    try:
+        repository = a_bzrdir.open_repository()
+        repository.lock_read()
+        try:
+            ret['location'] = info_helper.get_location_info(repository)
+            ret['format'] = info_helper.get_format_info(control, repository)
+            ret['locking'] = info_helper.get_locking_info(repository)
+            ret['repstats'] = info_helper.get_repository_stats(repository)
+        finally:
+            repository.unlock()
+            return ret
+        return
+    except errors.NoRepositoryPresent:
+        pass
+
 
 class OliveInfo:
     """ Display Informations window and perform the needed actions. """
@@ -50,12 +160,10 @@
         # Check if current location is a branch
         self.notbranch = False
         try:
-            self.ret = info.info(self.comm.get_path())
+            self.ret = info(self.comm.get_path())
         except errors.NotBranchError:
             self.notbranch = True
             return
-        except:
-            raise
         
         # Dictionary for signal_autoconnect
         dic = { "on_button_info_close_clicked": self.close,

=== modified file 'olive/frontend/gtk/push.py'
--- olive/frontend/gtk/push.py	2006-09-04 23:33:13 +0000
+++ olive/frontend/gtk/push.py	2006-09-05 01:51:53 +0000
@@ -28,9 +28,7 @@
 except:
     sys.exit(1)
 
-import olive.backend.commit as commit
 import bzrlib.errors as errors
-import olive.backend.info as info
 
 class OlivePush:
     """ Display Push dialog and perform the needed actions. """
@@ -70,13 +68,14 @@
         # Get stored location
         self.notbranch = False
         try:
-            loc = info.get_push_location(self.comm.get_path())
+            from bzrlib.branch import Branch
+    
+            branch = Branch.open_containing(self.comm.get_path())[0]
+    
+            self.entry_stored.set_text(branch.get_push_location())
         except errors.NotBranchError:
             self.notbranch = True
             return
-
-        if loc is not None:
-            self.entry_stored.set_text(loc)
     
     def display(self):
         """ Display the Push dialog. """
@@ -118,7 +117,7 @@
         self.comm.set_busy(self.window)
         if self.radio_stored.get_active():
             try:
-                revs = commit.push(self.comm.get_path(),
+                revs = do_push(self.comm.get_path(),
                                    overwrite=self.check_overwrite.get_active())
             except errors.NotBranchError:
                 self.dialog.error_dialog(_('Directory is not a branch'),
@@ -146,7 +145,7 @@
                 return
             
             try:
-                revs = commit.push(self.comm.get_path(), location,
+                revs = do_push(self.comm.get_path(), location,
                                    self.check_remember.get_active(),
                                    self.check_overwrite.get_active(),
                                    self.check_create.get_active())
@@ -208,3 +207,88 @@
     
     def close(self, widget=None):
         self.window.destroy()
+
+def do_push(branch, location=None, remember=False, overwrite=False,
+         create_prefix=False):
+    """ Update a mirror of a branch.
+    
+    :param branch: the source branch
+    
+    :param location: the location of the branch that you'd like to update
+    
+    :param remember: if set, the location will be stored
+    
+    :param overwrite: overwrite target location if it diverged
+    
+    :param create_prefix: create the path leading up to the branch if it doesn't exist
+    
+    :return: number of revisions pushed
+    """
+    from bzrlib.branch import Branch
+    from bzrlib.transport import get_transport
+        
+    br_from = Branch.open_containing(branch)[0]
+    
+    stored_loc = br_from.get_push_location()
+    if location is None:
+        if stored_loc is None:
+            raise NoLocationKnown
+        else:
+            location = stored_loc
+
+    transport = get_transport(location)
+    location_url = transport.base
+
+    if br_from.get_push_location() is None or remember:
+        br_from.set_push_location(location_url)
+
+    old_rh = []
+
+    try:
+        dir_to = bzrlib.bzrdir.BzrDir.open(location_url)
+        br_to = dir_to.open_branch()
+    except NotBranchError:
+        # create a branch.
+        transport = transport.clone('..')
+        if not create_prefix:
+            try:
+                relurl = transport.relpath(location_url)
+                transport.mkdir(relurl)
+            except NoSuchFile:
+                raise NonExistingParent(location)
+        else:
+            current = transport.base
+            needed = [(transport, transport.relpath(location_url))]
+            while needed:
+                try:
+                    transport, relpath = needed[-1]
+                    transport.mkdir(relpath)
+                    needed.pop()
+                except NoSuchFile:
+                    new_transport = transport.clone('..')
+                    needed.append((new_transport,
+                                   new_transport.relpath(transport.base)))
+                    if new_transport.base == transport.base:
+                        raise PathPrefixNotCreated
+        dir_to = br_from.bzrdir.clone(location_url,
+            revision_id=br_from.last_revision())
+        br_to = dir_to.open_branch()
+        count = len(br_to.revision_history())
+    else:
+        old_rh = br_to.revision_history()
+        try:
+            try:
+                tree_to = dir_to.open_workingtree()
+            except NotLocalUrl:
+                # FIXME - what to do here? how should we warn the user?
+                #warning('This transport does not update the working '
+                #        'tree of: %s' % (br_to.base,))
+                count = br_to.pull(br_from, overwrite)
+            except NoWorkingTree:
+                count = br_to.pull(br_from, overwrite)
+            else:
+                count = tree_to.pull(br_from, overwrite)
+        except DivergedBranches:
+            raise DivergedBranchesError
+    
+    return count

=== modified file 'setup.py'
--- setup.py	2006-09-04 01:02:20 +0000
+++ setup.py	2006-09-05 01:51:53 +0000
@@ -60,7 +60,7 @@
       author='Szilveszter Farkas (Phanatic)',
       author_email='szilveszter.farkas@gmail.com',
       url='http://bazaar-vcs.org/Olive',
-      packages=['olive', 'olive.backend', 'olive.frontend',
+      packages=['olive', 'olive.frontend',
                 'olive.frontend.gtk', 'olive.frontend.gtk.viz'],
       scripts=['olive-gtk'],
       data_files=[('share/olive', ['olive.glade',

